
//Efficacit de la politique budgtaire(Codes Dynare) : 2019-2020
var Y IP IG C CR CNR G
KP KG L LR LNR
R W CM P PI PIW Q RB LAMBDAR LAMBDANR
T tau_c tau_k tau_l B U;
varexo e_m e_G e_IG e_tau_c e_tau_l e_tau_k;
parameters sigma phi alpha1 alpha2 alpha3 beta delta
deltaG psi theta thetaW psiW
//rhoG rhoIG rhotau_c rhotau_l rhotau_k rhom
gammaG gammaIG gammatau_c gammatau_l gammatau_k
phiG phiIG phitau_c phitau_l phitau_k
gammaR gammaPI gammaY tau_css tau_lss tau_kss phic omegaR Psi1 Psi2 chi;

alpha1 = 0.33; //11-Estimated by Kabuya, Ntagoma and Tsasa (2019)
alpha2 = 0.66; // Djinkpo (2019)
alpha3 = 0.07; //Djinkpo (2019)
beta = 0.99; //2-Umba (2017) and other studies 
delta = 0.15; //7-Akitoby and Cinyabuguma (2005) RDC
deltaG = 0.035; // Djinkpo (2019)
theta = 0.65; //9-Average of SW(0.742),CS(0.747),I(0.824)
thetaW = 0.45; //Costa (2016)
sigma = 1.3; //4-Umba(2017) average of different authors gives 1.4947, closed
phi = 1.5; //Costa (2016)
psi = 10; // Author
psiW = 20; //
tau_css = 0.16; //Ntogoma  et al. (2015)
tau_lss = 0.2; //Ntogoma et al. (2015)
tau_kss = 0.225; // Ntogoma et al. (2015)
phic = 0.9; //Author : les mnages congolais ont une 
            //habitude de consommation trs leve

omegaR = 0.1; //Author based on the DRC evidence or context
Psi2 = 1; //Costa (2016)
chi = 1;  //Costa (2016)
//Fiscal Policy Parameters
gammaG = 0.5; //Author :  the value estimated from DJ (2019) is 0.8, pretty closed
gammaIG = 0.1; //Costa (2016)
gammatau_c = 0.507; //13-From I(0.507) 
gammatau_l =  0.568; //14- from I(0.568) 
gammatau_k = 0.6003; //15- DJ(0.6003)
phiG = 0.2;//17-Djinkpo(2019) similar to our model
phiIG = 0.3; //Djinkpo (2016)
phitau_c =  0.01; //18-Iwata(0.013) same equation like ours
phitau_l = 0.01;  //19-Iwata(0.005) 
phitau_k = 0.01; //20-Average FMS(0.57) and Iwata(0.123)
//Taylors Rule Parameters
gammaR = 0.8; //Costa (2016)
gammaY = 0.5; // Djinkpo (2019) and Costa (2016)
gammaPI = 1.5; //Djinkpo (2019) and Costa (2016)
//Autoregressive Shock Parameters
//rhoa = 0.8; // Costa (2016)
Psi1 = (1+tau_css)*((1/beta)-(1-delta)); //Model

model(linear);
#phiB =0.1430 ; //Following the data on DRC : calibrated to such that 
                // the values match the moments of the data
#phi_IG=0.2010; //Calibrated to match the moments of the data 
#Uss = 1;
#Pss = 1;
#PIss = 1;
#RBss = 1/beta;
#Rss = Pss*((1+tau_css)/(1-tau_kss))*((1/beta)-(1-delta));
#CMss = ((psi-1)/psi)*(1-beta*theta)*Pss;
#Wss = alpha2*((CMss*0.2^alpha3)^(1/alpha2))*((alpha1/Rss)^(alpha1/alpha2));
#A1 = ((1-phic*beta)*((1-phic)^(-sigma))*(1-beta*thetaW)*((psiW-1)/psiW)
*((1-tau_lss)/(1+tau_css))*(Wss/Pss)*(Wss/(alpha2*CMss))^phi)^(1/sigma);
#A2 = (((Rss*(Pss-tau_lss*(1-alpha1)*CMss)-tau_kss*(Rss-delta)
*alpha1*CMss)/(Pss*Rss*(1+tau_css)))-(delta*alpha1*CMss/Rss)
-(phiB/Pss)*((1/RBss)-1));
#Yss = (A1/A2)^(sigma/(sigma+phi));
#Bss = phiB*Yss;
#Lss = alpha2*CMss*(Yss/Wss);
#LRss = Lss;
#LNRss = Lss;
#KPss = alpha1*CMss*(Yss/Rss);
#IPss = delta*KPss;
#IGss = phi_IG*Yss;
#KGss = IGss/deltaG;
#Css = (1/(Yss^(phi/sigma)))*A1;
#CRss = Css;
#CNRss = Css;
#Gss = Yss - IPss - IGss - Css;
#Tss = Pss*Gss + Pss*IGss - Bss*((1/RBss)-1);
#LAMBDARss = ((CRss^(-sigma))*(1-phic*beta)
*(1-phic)^(-sigma))/((1+tau_css)*Pss);
#LAMBDANRss = ((CNRss^(-sigma))*(1-phic*beta)
*(1-phic)^(-sigma))/((1+tau_css)*Pss);
#Qss = LAMBDANRss*Pss*(1+tau_css);
//1-Ricardian Lagrangian household
LAMBDAR + P + (tau_css/(1+tau_css))*tau_c = (sigma/((1-phic)
*(1-phic*beta)))*(phic*beta*(CR(+1)-CR)-(CR-CR(-1)));
//2-Phillips equation for Ricardian household wages
PIW = beta*PIW(+1)+((1-thetaW)*(1-beta*thetaW)/thetaW)
*(phi*LR-LAMBDAR+(tau_lss/(1-tau_lss))*tau_l);
//3-Gross wage inflations
PIW = W - W(-1);
//4-Ricardian household budget constraint
//5-Tobins Q
(Qss/beta)*Q = (1-delta)*Qss*Q(+1) + LAMBDARss*Rss*Uss
*(1-tau_kss)*(LAMBDAR(+1)+R(+1)+U(+1)-(tau_kss/(1-tau_kss))*tau_k(+1))-LAMBDARss*Pss*Uss*Psi1*U(+1);
//6-Demand for installed capacity
(1-tau_kss)*(Rss/Pss)*(R-P-(tau_kss/(1-tau_kss))*tau_k)=Psi2*Uss*U;
//7-Demand for investments
(1+tau_css)*LAMBDARss*Pss*(LAMBDAR+P+(tau_css/(1+tau_css))*tau_c)
-Qss*Q+chi*Qss*(IP-IP(-1))=chi*beta*Qss*(IP(+1)-IP);
//8-Law of motion of private capital
KP = (1-delta)*KP(-1) + delta*IP;
//9-Eulers equation (Public bond)
LAMBDAR - RB = LAMBDAR(+1);
//10-Non-Ricardian household Lagrangian
LAMBDANR + P + (tau_css/(1+tau_css))*tau_c
= (sigma/((1-phic)*(1-phic*beta)))*(phic*beta*(CNR(+1)-CNR)-(CNR-CNR(-1)));
//11-Phillips equation for non-Ricardian household wages
PIW = beta*PIW(+1)+((1-thetaW)*(1-beta*thetaW)/thetaW)
*(phi*LNR-LAMBDANR+(tau_lss/(1-tau_lss))*tau_l);
//11-Non-Ricardian household Budget contraint
Pss*CRss*((P+CR)*(1+tau_css)+tau_css*tau_c) = Wss*LRss
*((W+LR)*(1-tau_lss)-tau_lss*tau_l);
//12-Aggregate consumption
Css*C = omegaR*CRss*CR + (1-omegaR)*CNRss*CNR;
//13-Aggregate labor
Lss*L = omegaR*LRss*LR + (1-omegaR)*LNRss*LNR;
//14-Production Function
Y = alpha1*(U+KP(-1)) + alpha2*L + alpha3*KG(-1);
//15- Problem of the firm trade-off (MRS=Relative price)
L - U - KP(-1) = R - W;
//16-Marginal Cost
CM = alpha2*W + alpha1*R - alpha3*KG(-1);
//17-Phillips Equation
PI = beta*PI(+1) + ((1-theta)*(1-beta*theta)/theta)*(CM-P);
//18-Gross Inflation Rate
PI(+1) = P(+1) - P;
//19-Government budget constraint
(Bss/RBss)*(B-RB)-Bss*B(-1) + Tss*T = Pss*Gss*(P+G)
+ Pss*IGss*(P+IG);
//20-Government tax revenue
Tss*T = tau_css*Pss*(Css*(C+P+tau_c)+IPss*(IP+P+tau_c))
+tau_lss*Wss*Lss*(W+L+tau_l)
+tau_kss*KPss*(Rss*(R+KP(-1)+tau_k)-delta*(KP(-1)+tau_k));
//21-Rule for the movement of public capital
KG(+1) = (1-deltaG)*KG + deltaG*IG;
//22-Rule for the movement of public spending
G = gammaG*G(-1) + (1-gammaG)*phiG*(B(-1)-Y(-1)-P(-1))+ e_G;
//23-Rule for the movement of public investment
IG = gammaIG*IG(-1) + (1-gammaIG)*phiIG*(B(-1)-Y(-1)-P(-1)) + e_IG;
//24-Rule for the movement of transfer of income
//25-Rule for the movement of tax on consumption
tau_c = gammatau_c*tau_c(-1) + (1-gammatau_c)
*phitau_c*(B(-1)-Y(-1)-P(-1)) - e_tau_c;
//26-Rule for the movement of tax on labor Income
tau_l = gammatau_l*tau_l(-1) + (1-gammatau_l)
*phitau_l*(B(-1)-Y(-1)-P(-1)) - e_tau_l;
//27-Rule for the movement of tax on consumption
tau_k = gammatau_k*tau_k(-1) + (1-gammatau_k)
*phitau_k*(B(-1)-Y(-1)-P(-1)) - e_tau_k;
//28-Taylors rule
RB = gammaR*RB(-1)+(1-gammaR)*(gammaPI*PI + gammaY*Y) - e_m;
//29-Equilibrim condition
Yss*Y = Css*C + IPss*IP + IGss*IG + Gss*G;
//30-Productivity shock
//A = rhoa*A(-1) + e;
end;

varobs tau_c tau_l B;

steady;
check;

estimated_params;
alpha2, beta_pdf, 0.66, 0.05;
alpha3, beta_pdf, 0.07, 0.01;
beta, beta_pdf, 0.99, 0.002; 
deltaG, beta_pdf, 0.035, 0.002; 
theta, inv_gamma_pdf, 0.65, 0.02; 
thetaW, inv_gamma_pdf, 0.45, 0.02; 
sigma, gamma_pdf, 1.3, 0.02; 
phi, gamma_pdf, 1.5, 0.5; 
psi, gamma_pdf, 10, 2; //The analysis I've done yesterday revealed
                      // that parameter value should not be far from 8.
psiW, gamma_pdf, 20, 2; // Not far from the value specified in Costa (2019) 
phic, beta_pdf, 0.9, 0.05; 
omegaR, beta_pdf, 0.3, 0.01;  
//Fiscal Policy Parameters
gammaG, beta_pdf, 0.5, 0.01; 
gammaIG, beta_pdf, 0.1, 0.010; 
gammatau_c, beta_pdf, 0.507, 0.1; 
gammatau_l, beta_pdf, 0.568, 0.1;  
gammatau_k, beta_pdf, 0.6003, 0.1; 
phiG, normal_pdf, 0.2, 0.1; 
phiIG, normal_pdf, 0.3, 0.1; 
phitau_c, normal_pdf, 0.01, 0.05; 
phitau_l, normal_pdf, 0.01, 0.05;  
phitau_k, normal_pdf, 0.01, 0.05; 
//Taylors Rule Parameters
gammaR, beta_pdf, 0.8, 0.05; 
gammaY, normal_pdf, 0.5, 0.05; 
gammaPI, normal_pdf, 1.5, 0.05; 
//Autoregressive Shock Parameters
//rhoa, beta_pdf, 0.8, 0.05;
//Standard error shocks parameters
//stderr e, inv_gamma_pdf, 0.4, 2;
stderr e_m, inv_gamma_pdf, 0.1, 2;
stderr e_G, inv_gamma_pdf, 0.3, 2;
stderr e_IG,inv_gamma_pdf, 0.3, 2;
stderr e_tau_c, inv_gamma_pdf, 0.1, 2; 
stderr e_tau_l,inv_gamma_pdf, 0.1, 2;
stderr e_tau_k, inv_gamma_pdf, 0.4, 2; 
end;


estimation(datafile=BD_banza_finale,mode_compute=4,
nobs=81,first_obs=1,mh_replic=10000,mh_nblocks=2,mh_jscale=0.4,
conditional_variance_decomposition=[1,4,8,16,32]);
write_latex_prior_table;  

shock_decomposition Y PI;


shocks;
//var e; stderr 0.01;
var e_G; stderr 0.01;
var e_IG; stderr 0.01;
var e_tau_c; stderr 0.01;
var e_tau_l; stderr 0.01;
var e_tau_k; stderr 0.01;
var e_m; stderr 0.01;
end;
stoch_simul(irf=40,hp_filter=1600)
Y IP C CR CNR R RB PI G IG tau_c tau_l tau_k;
